﻿using RobotBehaviourEditor.Model.Physics;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Windows;
using System;
using System.Windows.Media.Media3D;

namespace RobocupTestProject
{
    
    
    /// <summary>
    ///This is a test class for MathHelperTest and is intended
    ///to contain all MathHelperTest Unit Tests
    ///</summary>
    [TestClass()]
    public class MathHelperTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for GetClockwiseAngleTo
        ///</summary>
        [TestMethod()]
        public void GetClockwiseAngleToTest()
        {
            GetClockwiseAngleToTest2(0, 20, 1, 1, Math.PI / 4);
            GetClockwiseAngleToTest2(30, 30, 1, 0, Math.PI / 4);
            GetClockwiseAngleToTest2(23, 23, 1, -1, Math.PI / 2);
            GetClockwiseAngleToTest2(0, -1, 0, 1, Math.PI);
            GetClockwiseAngleToTest2(-1, 0, -45, 45, Math.PI / 4);
            GetClockwiseAngleToTest2(-1, 1, -1, 0, 7 * Math.PI / 4);
            GetClockwiseAngleToTest2(-12, 54, 35, 0.33, 1.78003);
            GetClockwiseAngleToTest2(45, 96.31, 91.32, 4, 1.08992);
            GetClockwiseAngleToTest2(-36, 3, -1, 0, 6.20004);
            GetClockwiseAngleToTest2(-4, -446, -62, -99, 0.55053);
        }

        void GetClockwiseAngleToTest2(double vector1X, double vector1Y, double vector2X, double vector2Y, double expected)
        {
            double actual = MathHelper.GetClockwiseAngleTo(
                new Vector(vector1X, vector1Y),
                new Vector(vector2X, vector2Y));

            Assert.IsTrue(Math.Abs(expected - actual) < 0.001);
        }

        /// <summary>
        ///A test for GetRotated
        ///</summary>
        [TestMethod()]
        public void GetRotatedTest()
        {
            GetRotatedTest2(new Vector3D(1, 1, 0), new Point3D(1, 0, 0), 180, new Point3D(0, 1, 0));
            GetRotatedTest2(new Vector3D(12, 12, 0), new Point3D(56, 0, 0), 90, new Point3D(28, 28, -39.59));
            GetRotatedTest2(new Vector3D(1, 1, 1), new Point3D(5, 6, 7), 270, new Point3D(5.42, 7.15, 5.42));
            GetRotatedTest2(new Vector3D(84, 35.657, 23), new Point3D(23, 45, 67), 196, new Point3D(68.37, 11.77, -47.21));
            GetRotatedTest2(new Vector3D(44, -96, 0), new Point3D(4, 0, 4), 143, new Point3D(-4.13, -3.72, -1));
            GetRotatedTest2(new Vector3D(1, 1, 0), new Point3D(0, 0, 0), 0, new Point3D(0, 0, 0));
            GetRotatedTest2(new Vector3D(1, 1, 0), new Point3D(1, 0, 0), 0, new Point3D(1, 0, 0));
            GetRotatedTest2(new Vector3D(1, 1, 0), new Point3D(0, 0, 0), 96, new Point3D(0, 0, 0));
            GetRotatedTest2(new Vector3D(1004, 354, -569), new Point3D(5849.32, 55, 74), 360, new Point3D(5849.32, 55, 74));
            GetRotatedTest2(new Vector3D(46, 83, 4), new Point3D(1, 23, 0), 89, new Point3D(8.84, 18.11, 11.11));
            GetRotatedTest2(new Vector3D(-35, 1, 0), new Point3D(1, 56, 4), 12.435, new Point3D(0.98, 55.54, -8.15));
        }

        void GetRotatedTest2(Vector3D axis, Point3D point, double angle, Point3D expected)
        {
            Point3D actual = MathHelper.GetRotated(point, axis, angle);
            Assert.IsTrue(Math.Abs(expected.X - actual.X) < 1);
            Assert.IsTrue(Math.Abs(expected.Y - actual.Y) < 1);
            Assert.IsTrue(Math.Abs(expected.Z - actual.Z) < 1);
        }
    }
}
