﻿using RobotBehaviourEditor.Model.Physics;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Windows;

namespace RobocupTestProject
{
    
    
    /// <summary>
    ///This is a test class for StabilityHullTest and is intended
    ///to contain all StabilityHullTest Unit Tests
    ///</summary>
    [TestClass()]
    public class StabilityHullTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for StabilityHull Constructor
        ///</summary>
        [TestMethod()]
        public void StabilityHullConstructorTest1()
        {
            Point[] points = new Point[]
            {
                new Point(-3, -2),
                new Point(-3, 0),
                new Point(-3, 2),
                new Point(-2, 0),
                new Point(-1, 3),
                new Point(0, -3),
                new Point(0, -1),
                new Point(0, 0),
                new Point(1, 0),
                new Point(1, 2),
                new Point(2, -1),
                new Point(3, 2),
                new Point(3, 1),
                new Point(3, 0),
                new Point(3, -1),
            };

            StabilityHull target = new StabilityHull(points);

            Assert.AreEqual<int>(target.Points.Count, 9);
            Assert.IsTrue(target.Points.Contains(new Point(-3, -2)));
            Assert.IsTrue(target.Points.Contains(new Point(-3, 0)));
            Assert.IsTrue(target.Points.Contains(new Point(-3, 2)));
            Assert.IsTrue(target.Points.Contains(new Point(-1, 3)));
            Assert.IsTrue(target.Points.Contains(new Point(3, 2)));
            Assert.IsTrue(target.Points.Contains(new Point(3, 1)));
            Assert.IsTrue(target.Points.Contains(new Point(3, 0)));
            Assert.IsTrue(target.Points.Contains(new Point(3, -1)));
            Assert.IsTrue(target.Points.Contains(new Point(0, -3)));
        }

        [TestMethod()]
        public void StabilityHullConstructorTest2()
        {
            Point[] points = new Point[]
            {                
                new Point(1, 1),
                new Point(0, 0),
                new Point(0, 0.5),
                new Point(-1, 1),
            };

            StabilityHull target = new StabilityHull(points);

            Assert.AreEqual<int>(target.Points.Count, 3);
            Assert.IsTrue(target.Points.Contains(new Point(-1, 1)));
            Assert.IsTrue(target.Points.Contains(new Point(1, 1)));
            Assert.IsTrue(target.Points.Contains(new Point(0, 0)));
        }

        [TestMethod()]
        public void StabilityHullConstructorTest3()
        {
            Point[] points = new Point[]
            {                
                new Point(24, 94),
                new Point(34.565, -354),
                new Point(567.3, 34),
                new Point(-12, 1),
                new Point(93, 23),
                new Point(-59, -44),
                new Point(9, 9),
                new Point(-34, 56),
                new Point(95, 1254),
            };

            StabilityHull target = new StabilityHull(points);

            Assert.AreEqual<int>(target.Points.Count, 4);
            Assert.IsTrue(target.Points.Contains(new Point(-59, -44)));
            Assert.IsTrue(target.Points.Contains(new Point(95, 1254)));
            Assert.IsTrue(target.Points.Contains(new Point(567.3, 34)));
            Assert.IsTrue(target.Points.Contains(new Point(34.565, -354)));
        }
    }
}
