﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using RobotBehaviourEditor.Library;
using RobotBehaviourEditor.MotionEditor.Configuration;
using RobotBehaviourEditor.MotionEditor;

namespace RobotBehaviourEditor
{
    public partial class BehaviourEditorForm : Form
    {
        private BrowserForm browserForm;

        private static BehaviourEditorForm instance = null;

        public static BehaviourEditorForm mainWindow()
        {
            return instance;
        }

        public BehaviourEditorForm()
        {
            InitializeComponent();

            if (instance == null)
                instance = this;
        }

        private void browserLibraryMenuItem_Click(object sender, EventArgs e)
        {
            if (browserForm == null || browserForm.IsDisposed)
            {
                browserForm = new BrowserForm();
                browserForm.MdiParent = this;
                browserForm.Show();
                browserForm.WindowState = FormWindowState.Maximized;
            }
            else
            {
                browserForm.Activate();
            }
        }

        private void settingsMenuItem_Click(object sender, EventArgs e)
        {
            ConfigForm frm = new ConfigForm();
            frm.ShowDialog(this);
        }

        private void newMotionMenuItem_Click(object sender, EventArgs e)
        {
            Commands.CreateNewMotion(this);
        }

        private void importMotionMenuItem_Click(object sender, EventArgs e)
        {
            importFileDialog.ShowDialog(this);
        }

        private void importFileDialog_FileOk(object sender, CancelEventArgs e)
        {
            Library.Library.ImportMotion(importFileDialog.FileName);
        }

        private void BehaviourEditorForm_Load(object sender, EventArgs e)
        {
            browserLibraryMenuItem_Click(this, new EventArgs());
        }

        private void newPreconditionMenuItem_Click(object sender, EventArgs e)
        {            
        }

        private void aboutMenuItem_Click(object sender, EventArgs e)
        {
            AboutForm frm = new AboutForm();
            frm.ShowDialog(this);
        }
    }
}
