﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using RobotBehaviourEditor.MotionEditor;
using System.Windows.Forms;
using RobotBehaviourEditor.Model;

namespace RobotBehaviourEditor
{
    public static class Commands
    {

        internal static void CreateNewMotion(Form mdiParent)
        {
            MotionEditorForm frm = new MotionEditorForm();
            frm.MdiParent = mdiParent;
            frm.Show();
        }

        internal static void ImportServerMessageFile()
        {
            OpenFileDialog dlg = new OpenFileDialog();
            dlg.Title = "Importovať súbor so správou zo servera...";
            dlg.ShowDialog();

            if (dlg.FileNames.Length > 0)
            {
                Library.Library.ImportServerMessages(dlg.FileName);
            }
        }

        /*
         *  Called from the basic action panel
         */ 
        internal static void ImportXmlMessageFile()
        {
            OpenFileDialog dlg = new OpenFileDialog();
            dlg.RestoreDirectory = true;
            dlg.Filter = "Xml files of Jim (*.xml)|*.xml|Xml files of Dream Team derivates (*.xml)|*.xml";
            dlg.Title = "Import from XML File";
            dlg.ShowDialog();

            if (dlg.FileNames.Length > 0)
            {
                switch (dlg.FilterIndex)
                {
                    case 1:
                        Library.Library.ImportMovesFromXml(dlg.FileName, Library.Library.XML_JIM_PLAYER);
                        break;
                    case 2:
                        Library.Library.ImportMovesFromXml(dlg.FileName,Library.Library.XML_DREAM_TEAM_PLAYER);
                        break;
                }
            }
        }

        internal static void ExportXmlMessageFile(List<State> states)
        {
            SaveFileDialog dlg = new SaveFileDialog();

            dlg.Filter = "Xml files for Jim (*.xml)|*.xml|Xml files (*.xml)|*.xml";
            dlg.Title = "Export to XML File";
            dlg.RestoreDirectory = true;
            dlg.ShowDialog();

            if (dlg.FileNames.Length > 0)
            {
                switch(dlg.FilterIndex)
                {
                    case 1:
                        MotionEditor.MotionEditorForm.ExportMovesToXml(dlg.FileName, states,MotionEditorForm.XML_JIM_PLAYER);
                        break;
                    case 2:
                        MotionEditor.MotionEditorForm.ExportMovesToXml(dlg.FileName, states,MotionEditorForm.XML_CRITICAL_ERROR_PLAYER);
                        break;
                }
            }
        }
    }
}
