﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;

namespace RobotBehaviourEditor.Controls
{
    public partial class HidablePanel : Panel
    {
        public HidablePanel()
        {
            InitializeComponent();            
        }

        protected override Padding DefaultPadding
        {
            get
            {
                return new Padding(5, 25, 5, 5);
            }
        }

        [Browsable(true), DesignerSerializationVisibility(DesignerSerializationVisibility.Visible)]
        public override string Text
        {
            get
            {
                return base.Text;
            }
            set
            {
                base.Text = value;
                this.Invalidate();
            }
        }

        protected override void OnPaint(PaintEventArgs pe)
        {
            base.OnPaint(pe);

            Graphics g = pe.Graphics;
            Rectangle titleRect = new Rectangle(0, 0, this.Width - 1, 20);
            g.FillRectangle(new LinearGradientBrush(titleRect, SystemColors.ActiveCaption, SystemColors.GradientActiveCaption, LinearGradientMode.Vertical),
                titleRect);
            Rectangle glossRect = new Rectangle(titleRect.Left, titleRect.Top, titleRect.Width, titleRect.Height / 2);
            g.FillRectangle(new LinearGradientBrush(glossRect, Color.FromArgb(180, Color.White),
                Color.FromArgb(40, Color.White), LinearGradientMode.Vertical),
                glossRect);

            StringFormat sf = new StringFormat()
            {
                Alignment = StringAlignment.Center,
                LineAlignment = StringAlignment.Center
            };

            g.DrawString(Text, SystemFonts.CaptionFont, SystemBrushes.ActiveCaptionText, titleRect, sf);            

            g.DrawRectangle(Pens.Black, titleRect);            
        }
    }
}
