﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;

namespace RobotBehaviourEditor.Formats
{
    /**
     *  A class representation of an &lt;effector&gt; tag in Dream Team's XML
     * */
    class EffectorNode
    {
        public string jointName { get; set; }
        public double startAngle { get; set; }
        public double endAngle { get; set; }

        public static EffectorNode parse(XmlReader reader)
        {
            EffectorNode node = new EffectorNode();
            while (reader.MoveToNextAttribute())
                if ("name".Equals(reader.Name))
                    node.jointName = reader.Value;

            while (reader.Read())
            {
                if (reader.NodeType == XmlNodeType.Element && reader.Name.Equals("start"))
                {
                    reader.Read();
                    node.startAngle = double.Parse(reader.Value);
                }
                if (reader.NodeType == XmlNodeType.Element && reader.Name.Equals("end"))
                {
                    reader.Read();
                    node.endAngle = double.Parse(reader.Value);
                    break;
                }
            }

            return node;
        }

        string ToString()
        {
            return "<effector name ='" + jointName + "'>" +
                   "<start>" + startAngle + "</start>" +
                   "<end>" + endAngle + "</end></effector>";
        }
    }
}
