﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;

namespace RobotBehaviourEditor.Formats
{
    /**
     *  A class representation of an &lt;effector&gt; tag in Xml for Jim
     * */
    class EffectorNodeForJim
    {
        public string jointName { get; set; }
        public double startAngle { get; set; }
        public double endAngle { get; set; }

        public static EffectorNodeForJim parse(XmlReader reader)
        {
            EffectorNodeForJim node = new EffectorNodeForJim();
            node.jointName = reader.Name;
            
            while (reader.MoveToNextAttribute())
                if ("end".Equals(reader.Name))
                    node.endAngle = double.Parse(reader.Value);
            return node;
        }

        string ToString()
        {
            return "<" + jointName + " end='" + endAngle + " '/>";
        }
    }
}