﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using RobotBehaviourEditor.Model;
using RobotBehaviourEditor.MotionEditor.Visualisation;
using RobotBehaviourEditor.MotionEditor;

namespace RobotBehaviourEditor.Formats
{
    public partial class ImportXmlLowSkillPicker : Form
    {
        private List<String> lowSkills;

        private IXmlImporter importer;

        public ImportXmlLowSkillPicker(IXmlImporter importer)
        {
            this.importer = importer;
            this.lowSkills = importer.lowLevelSkillsInFile();
            InitializeComponent();
        }
        
        //invoked by clicking on Proceed button
        private void proceedWithImport(object sender, EventArgs e)
        {
            string pickedLowSkill = this.lowSkillsList.SelectedItem.ToString();
            List<JointMotion> motions = importer.movesOf(pickedLowSkill);
            State encapsulatingState = new State(pickedLowSkill);
            encapsulatingState.AddMotions(motions.ToArray());
            RobotMotion guiMotions = new RobotMotion();
            guiMotions.AddState(encapsulatingState);
            MotionEditorForm form = new MotionEditorForm(guiMotions);
            form.MdiParent = BehaviourEditorForm.mainWindow();
            form.Text = "Pohyby - " + pickedLowSkill;
            form.Visible = true;
            this.Dispose();
        }
    }
}