﻿/* Parser Logov
 * Ivan Hujsi 
 * Tim 17
 * FIIT STU BA
 * 10.3.2010
 * v 1.1
 */


using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using RobotBehaviourEditor.Utils;
using RobotBehaviourEditor.Model;

namespace RobotBehaviourEditor.Formats
{
    class ParserPrototyp
    {
        //zoznam premennych a konstan potrebnych pre vypocet 
        //Maximalny pocet hracov na ihrisku - momentalne sa hra 3v3
        private const int PIFCOUNT = 6;
        //Pocet casti robotov
        private const int ROBOPARTSCOUNT = 23;
        //pole stringov obsahujuce informacie o objekte
        private static string[] coordin = new string[50];
        //pole stringov obsahujuce skupiny objektov v 3 casti riadku
        private static string[] partsOfPartsOfLinePartThree = new string[24];
        //matica obsahujuca rotacne matice objektov, z ktorych sa sklada jeden robot
        private static double[][] objectPseudoMatrixes = new double[ROBOPARTSCOUNT][];
        //alfa, beta, gama - uhly otocenia osi omega - sucet uhlov na vypocet natocenia klbov 
        private static double alfa, beta, gama, omega;
        //cyklus hodnota ziskana zo zaznamu
        private static double time = 0;
        //zaciatocny cyklus
        private static int begin = 0;
        //koncovy cyklus
        private static int stop = 300;
        //nastavenie polcasu
        private static int adjust = -1;
        //cislo hraca
        private static int player = -1;
        //nove natocenia uhlov
        private static double[] joints = new double[22];
        //stare natocenia uhlov
        private static double[] oldjoints = new double[22];
        //zoznam pohybov ktore su poslane editoru
        public static List<JointMotion> jointMotions = new List<JointMotion>();
        private static double timeBefore = 0;
        private static double actiontime = 0;
        private static double starttime = 0;
        private static double endtime = 0;
        private static bool first = true;

        //hlavna funkcia parsera berie 3 argumenty hrac zaciatocny koncovy cyklus
        //***bolo by vhodne doplnit o vyber suboru
        public static void parse(int playerinfo, int begininfo, int stopinfo)
        {
            first = true;
            begin = begininfo;
            stop = stopinfo;
            if (begin > 300 || stop < begin)//nevhodne zadane rozmery cyklov sposobia ukoncenie 
            {
                return;
            }
            time = 0;
            timeBefore = 0;
            actiontime = 0;
            starttime = 0;
            endtime = 0;
            Console.WriteLine("began");//nepadlo to na zadanych datach
            //kontrolne vystupy v txt suboroch
            //System.IO.File.WriteAllText(@".\vystup1.txt", "");
            //System.IO.File.WriteAllText(@".\vystup2.txt", "");
            //System.IO.File.WriteAllText(@".\vystup3.txt", "");
            //System.IO.File.WriteAllText(@".\vystup4.txt", "");
            //System.IO.File.WriteAllText(@".\vystup5.txt", "");
            init();//inicializacia
            jointMotions.Clear();//vymazanie pohybov
            player = playerinfo;
            //rozdelenie parsovaneho suboru na riadky
            string[] lines = System.IO.File.ReadAllLines(@".\sparkmonitor.log");

            //pre kazdy riadok
            foreach (string line in lines)
            {
                if (line.StartsWith("((time"))//ide len o zistenie casu
                {
                    string[] gettime = line.Split(')');
                    string[] gottime = gettime[0].Split(' ');
                    time = double.Parse(gottime[1]);
                    if (adjust == -1)
                    {
                        adjust = int.Parse(gottime[1]);
                    }
                    if (time > stop + adjust)
                    {
                        Console.WriteLine("Press any key to exit.");
                        //System.Console.ReadKey();
                        return;
                    }
                }
                //funkcia na rozobratie riadku
                parseLine(line);
                starttime = endtime;
                timeBefore = time;
            }
            //zastavenie na konci
            Console.WriteLine("Press any key to exit.");
            //System.Console.ReadKey();
        }

        //
        public static void parseLine(string line)
        {
            //System.IO.File.WriteAllText(@".\vystup1.txt", "");
            //System.IO.File.WriteAllText(@".\vystup2.txt", "");
            //System.IO.File.WriteAllText(@".\vystup3.txt", "");
            int start = 0;//zaciatok zatvoriek
            int depth = 0;//hlbka vnorenie v zatvorkach
            int end = 0;//koniec zatvoriek
            string linePartThree = "";//retazec na ulozenie tretej casti riadku (obsahuje vsetky objekty)
            for (int i = 0; i < line.Length; i++)//prechadza cely riadok po znakoch
            {
                if (line.Substring(i, 1) == "(")//tento znak znamena vnorenie
                {
                    depth++;//zvysenie hlbky
                    if (depth == 1)
                        start = i;//zaciatok casti
                }
                if (line.Substring(i, 1) == ")")//tento znak znamena vynorenie
                {
                    depth--;//znizenie hlbky
                    end = i;//koniec casti
                }
                if (depth == 0)
                {
                    linePartThree = line.Substring(start + 1, end - start - 1);//ulozenie casti riadku do urceneho retazca
                }
            }
            //System.IO.File.AppendAllText(@".\vystup1.txt", linePartThree + " \n");
            //System.IO.File.AppendAllText(@".\vystup2.txt", "Novy riadok \n");
            //System.IO.File.AppendAllText(@".\vystup3.txt", "Novy riadok \n");
            //System.IO.File.AppendAllText(@".\vystup4.txt", "Novy riadok \n");
            //System.IO.File.AppendAllText(@".\vystup5.txt", "Novy riadok \n");

            //rozobratie tretej casti riadku, ktora obsahuje objekty na jednotlive skupiny objektov
            start = 0;//zaciatok zatvoriek
            depth = 0;//hlbka
            end = 0;//koniec zatvoriek
            int part = 0;//pocitadlo casti
            string[] partsOfLinePartThree = new string[22];//pole na uchovanie casti tretej casti riadka
            partsOfLinePartThree[15 + player] = "";//pozadovany robot
            for (int i = 0; i < linePartThree.Length; i++)//prechadza cely riadok
            {
                if (linePartThree.Substring(i, 1) == "(")//tento znak znamena vnorenie
                {
                    depth++;//zvysenie hlbky
                    if (depth == 1)
                        start = i;//zaciatk casti 
                }
                if (linePartThree.Substring(i, 1) == ")")//tento znak znamena vynorenie
                {
                    depth--;//znizenie hlbky
                    end = i;//koniec casti
                }
                if (depth == 0)
                {
                    partsOfLinePartThree[part] = linePartThree.Substring(start + 1, end - start - 1);
                    //System.IO.File.AppendAllText(@".\vystup2.txt", partsOfLinePartThree[part] + " \n");
                    //System.IO.File.AppendAllText(@".\vystup3.txt", "Novy objekt \n");
                    //System.IO.File.AppendAllText(@".\vystup4.txt", "Novy objekt \n");
                    //System.IO.File.AppendAllText(@".\vystup5.txt", "Novy objekt \n");
                    part++;//pocitadlo casti
                }
            }

            //rozobratie vybrateho hraca na objekty
            start = -1;//zaciatok zatvoriek
            depth = 0;//hlbka
            end = 0;//koniec zatvoriek
            part = 0;//pocet casti objektu
            bool first = false;//bola najdena uz prva zatvorka?
            resetPartsOfPartsField();
            for (int i = 0; i < partsOfLinePartThree[15 + player].Length; i++)//prechadza cely riadok
            {
                if (partsOfLinePartThree[15 + player].Substring(i, 1) == "(")//tento znak znamena vnorenie
                {
                    depth++;//zvysenie hlbky
                    first = true;//nasla sa prva zatvorka
                    if (depth == 1)
                        start = i;//zaciatok casti 
                }
                if (partsOfLinePartThree[15 + player].Substring(i, 1) == ")")//tento znak znamena vynorenie
                {
                    depth--;//znizenie hlbky
                    end = i;//koniec casti
                }
                if (depth == 0 && first)
                {
                    partsOfPartsOfLinePartThree[part] = partsOfLinePartThree[15 + player].Substring(start + 1, end - start - 1);
                    //System.IO.File.AppendAllText(@".\vystup3.txt", partsOfPartsOfLinePartThree[part] + " \n");
                    //System.IO.File.AppendAllText(@".\vystup4.txt", "Nova cast objektu \n");
                    //System.IO.File.AppendAllText(@".\vystup5.txt", "Nova cast objektu \n");
                    part++;
                }
            }

            //vytvorenie pseudomatic zo ziskanych suborov objektov
            resetCoordin();
            for (int i = 23; i >= 0; i--)//od konca
            {
                if ((partsOfPartsOfLinePartThree[23].CompareTo("")) != 0)//ak je posledny prazdny ide o subor 23 zaznamov inak 24
                {
                    coordin = partsOfPartsOfLinePartThree[i].Split(' ');//split podla medzier
                    if (coordin.Count() > 1 && i > 0)//ak je po splite viac ako jeden string znamena to ze obsahuje viac ako len delimitery
                    {
                        for (int j = 0; j <= 14; j++)//kopirovanie 15 cisiel
                        {
                            int x;
                            if (coordin[1].CompareTo("TRF") != 0)//ak je tu TRF su cisla posunute o string dalej
                            {
                                x = 2;
                            }
                            else
                            {
                                x = 3;
                            }
                            objectPseudoMatrixes[i - 1][j] = Double.Parse(coordin[j + x]);//zapis do pseudo matice
                            //System.IO.File.AppendAllText(@".\vystup4.txt", objectPseudoMatrixes[i - 1][j] + " \n");
                        }
                        //Console.WriteLine(i);
                        //zakladne vypocty uhlov
                        /*alfa = Math.Atan2(objectPseudoMatrixes[i - 1][0], objectPseudoMatrixes[i - 1][1]);//theta
                        beta = Math.Atan2(Math.Sqrt(objectPseudoMatrixes[i - 1][6] * objectPseudoMatrixes[i - 1][6] + objectPseudoMatrixes[i - 1][10] * objectPseudoMatrixes[i - 1][10]), -objectPseudoMatrixes[i - 1][2]);//phi
                        gama = Math.Atan2(objectPseudoMatrixes[i - 1][6], objectPseudoMatrixes[i - 1][10]);//psi
                        //System.IO.File.AppendAllText(@".\vystup5.txt",(i-1) + " part " +alfa * 180 / Math.PI + " | " + beta * 180 / Math.PI + " | " + gama * 180 / Math.PI);
                        if (alfa < 0) alfa = 2 * Math.PI + alfa;
                        if (beta < 0) beta = 2 * Math.PI + beta;
                        if (gama < 0) gama = 2 * Math.PI + gama;
                        omega = alfa * 180 / Math.PI + beta * 180 / Math.PI + gama * 180 / Math.PI;
                        //System.IO.File.AppendAllText(@".\vystup5.txt", " |||| " + omega + "\n");
                        objectPseudoMatrixes[i - 1][15] = omega;
                        writePseudoMatrix(objectPseudoMatrixes[i-1]);*/
                    }
                }
                else//to iste co predtym pre 23 prvkov
                {
                    coordin = partsOfPartsOfLinePartThree[i].Split(' ');
                    if (coordin.Count() > 1 && i < 23)
                    {
                        for (int j = 0; j <= 14; j++)
                        {
                            int x;
                            if (coordin[1].CompareTo("TRF") != 0)
                            {
                                x = 2;
                            }
                            else
                            {
                                x = 3;
                            }
                            objectPseudoMatrixes[i][j] = Double.Parse(coordin[j + x]);
                            //System.IO.File.AppendAllText(@".\vystup4.txt", objectPseudoMatrixes[i][j] + " \n");
                        }
                        /*Console.WriteLine(i);
                        alfa = Math.Atan2(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1]);//theta
                        beta = Math.Atan2(Math.Sqrt(objectPseudoMatrixes[i][6] * objectPseudoMatrixes[i][6] + objectPseudoMatrixes[i][10] * objectPseudoMatrixes[i][10]), -objectPseudoMatrixes[i][2]);//phi
                        gama = Math.Atan2(objectPseudoMatrixes[i][6], objectPseudoMatrixes[i][10]);//psi
                        //System.IO.File.AppendAllText(@".\vystup5.txt",i +" part " +alfa * 180 / Math.PI + " | " + beta * 180 / Math.PI + " | " + gama * 180 / Math.PI);
                        if (alfa < 0) alfa = 2 * Math.PI + alfa;
                        if (beta < 0) beta = 2 * Math.PI + beta;
                        if (gama < 0) gama = 2 * Math.PI + gama;
                        omega = alfa * 180 / Math.PI + beta * 180 / Math.PI + gama * 180 / Math.PI;
                        //System.IO.File.AppendAllText(@".\vystup5.txt"," |||| " + omega + "\n");
                        objectPseudoMatrixes[i][15] = omega;
                        writePseudoMatrix(objectPseudoMatrixes[i]);*/
                    }
                }
            }
            jointCalculation();
        }

        private static void writePseudoMatrix(double[] matrix)
        {
            for (int i = 0; i < matrix.Length - 1; i++)
                System.IO.File.AppendAllText(@".\vystup5.txt", matrix[i] + " | ");
            System.IO.File.AppendAllText(@".\vystup5.txt", "\n");
        }
        private static void init()
        {
            for (int i = 0; i < 23; i++)
            {
                objectPseudoMatrixes[i] = new double[16];
            }
        }

        private static void resetPartsOfPartsField()
        {
            for (int i = 0; i <= 23; i++)
            {
                partsOfPartsOfLinePartThree[i] = "";
            }
        }

        private static void resetCoordin()
        {
            coordin = new string[50];
            for (int x = 0; x < 50; x++)
            {
                coordin[x] = "";
            }
        }

        private static double vectorAngle(double x1, double y1, double z1, double x2, double y2, double z2)
        {
            return Math.Acos((x1 * x2 + y1 * y2 + z1 * z2) / (Math.Sqrt(x1 * x1 + y1 * y1 + z1 * z1) * Math.Sqrt(x2 * x2 + y2 * y2 + z2 * z2)));
        }

        private static double signedVectorAngle(double x1, double y1, double z1, double x2, double y2, double z2, double rotx, double roty, double rotz)
        {
            double x, y, z;
            x = y1 * z2 - y2 * z1;
            y = z1 * x2 - z2 * x1;
            z = x1 * y2 - x2 * y1;

            return Math.Round(Math.Atan2(rotx * x + roty * y + rotz * z, x1 * x2 + y1 * y2 + z1 * z2) * 180 / Math.PI);
        }

        private static void jointCalculation()
        {
            int i, j;
            i = 1;
            j = 2;
            /*System.IO.File.AppendAllText(@".\vystup5.txt",
            " | 1. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2]) * 180 / Math.PI) +
            " | 2. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 3. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 4. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 5. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 6. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) + "\n");

            System.IO.File.AppendAllText(@".\vystup5.txt", signedVectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10], objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2]) + "\n");
            */
            joints[1] = signedVectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10], objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2]);

            i = 0;
            j = 1;
            /*System.IO.File.AppendAllText(@".\vystup5.txt",
            " | 1. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2]) * 180 / Math.PI) +
            " | 2. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 3. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 4. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 5. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 6. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) + "\n");

            System.IO.File.AppendAllText(@".\vystup5.txt", signedVectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2], objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10]) + "\n");
            */
            joints[0] = signedVectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2], objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10]);

            i = 0;
            j = 3;
            /*System.IO.File.AppendAllText(@".\vystup5.txt",
            " | 1. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2]) * 180 / Math.PI) +
            " | 2. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 3. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 4. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 5. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 6. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) + "\n");

            System.IO.File.AppendAllText(@".\vystup5.txt", signedVectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10], objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2]) + "\n");
            */
            joints[2] = signedVectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10], objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2]);

            i = 3;
            j = 4;
            /*System.IO.File.AppendAllText(@".\vystup5.txt",
            " | 1. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2]) * 180 / Math.PI) +
            " | 2. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 3. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 4. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 5. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 6. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) + "\n");

            System.IO.File.AppendAllText(@".\vystup5.txt", signedVectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6], objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10]) + "\n");
            */
            joints[3] = signedVectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6], objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10]);

            i = 4;
            j = 5;
            /*System.IO.File.AppendAllText(@".\vystup5.txt",
            " | 1. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2]) * 180 / Math.PI) +
            " | 2. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 3. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 4. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 5. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 6. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) + "\n");

            System.IO.File.AppendAllText(@".\vystup5.txt", signedVectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10], objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6]) + "\n");
            */
            joints[4] = signedVectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10], objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6]);

            i = 5;
            j = 6;
            /*System.IO.File.AppendAllText(@".\vystup5.txt",
            " | 1. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2]) * 180 / Math.PI) +
            " | 2. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 3. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 4. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 5. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 6. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) + "\n");

            System.IO.File.AppendAllText(@".\vystup5.txt", signedVectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2], objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10]) + "\n");
            */
            joints[5] = signedVectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2], objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10]);

            i = 0;
            j = 7;
            /*System.IO.File.AppendAllText(@".\vystup5.txt",
            " | 1. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2]) * 180 / Math.PI) +
            " | 2. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 3. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 4. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 5. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 6. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) + "\n");

            System.IO.File.AppendAllText(@".\vystup5.txt", signedVectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10], objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2]) + "\n");
            */
            joints[6] = signedVectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10], objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2]);

            i = 7;
            j = 8;
            /*System.IO.File.AppendAllText(@".\vystup5.txt",
            " | 1. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2]) * 180 / Math.PI) +
            " | 2. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 3. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 4. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 5. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 6. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) + "\n");

            System.IO.File.AppendAllText(@".\vystup5.txt", signedVectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6], objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10]) + "\n");
            */
            joints[7] = signedVectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6], objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10]);

            i = 8;
            j = 9;
            /*System.IO.File.AppendAllText(@".\vystup5.txt",
            " | 1. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2]) * 180 / Math.PI) +
            " | 2. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 3. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 4. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 5. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 6. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) + "\n");

            System.IO.File.AppendAllText(@".\vystup5.txt", signedVectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10], objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6]) + "\n");
            */
            joints[8] = signedVectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10], objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6]);

            i = 9;
            j = 10;
            /*System.IO.File.AppendAllText(@".\vystup5.txt",
            " | 1. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2]) * 180 / Math.PI) +
            " | 2. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 3. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 4. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 5. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 6. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) + "\n");

            System.IO.File.AppendAllText(@".\vystup5.txt", signedVectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2], objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10]) + "\n");
            */
            joints[9] = signedVectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2], objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10]);

            i = 0;
            j = 11;
            /*System.IO.File.AppendAllText(@".\vystup5.txt",
            " | 1. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2]) * 180 / Math.PI) +
            " | 2. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 3. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 4. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 5. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 6. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) + "\n");

            System.IO.File.AppendAllText(@".\vystup5.txt", signedVectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6], objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10]) + "\n");
            */
            joints[10] = signedVectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6], objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10]);

            i = 11;
            j = 12;
            /*System.IO.File.AppendAllText(@".\vystup5.txt",
            " | 1. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2]) * 180 / Math.PI) +
            " | 2. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 3. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 4. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 5. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 6. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) + "\n");

            System.IO.File.AppendAllText(@".\vystup5.txt", signedVectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2], objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6]) + "\n");
            */
            joints[11] = signedVectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2], objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6]);

            i = 12;
            j = 13;
            /*System.IO.File.AppendAllText(@".\vystup5.txt",
            " | 1. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2]) * 180 / Math.PI) +
            " | 2. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 3. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 4. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 5. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 6. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) + "\n");

            System.IO.File.AppendAllText(@".\vystup5.txt", signedVectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10], objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2]) + "\n");
            */
            joints[12] = signedVectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10], objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2]);

            i = 13;
            j = 14;
            /*System.IO.File.AppendAllText(@".\vystup5.txt",
            " | 1. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2]) * 180 / Math.PI) +
            " | 2. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 3. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 4. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 5. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 6. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) + "\n");

            System.IO.File.AppendAllText(@".\vystup5.txt", signedVectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6], objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2]) + "\n");
            */
            joints[13] = signedVectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6], objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2]);

            i = 14;
            j = 15;
            /*System.IO.File.AppendAllText(@".\vystup5.txt",
            " | 1. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2]) * 180 / Math.PI) +
            " | 2. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 3. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 4. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 5. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 6. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) + "\n");

            System.IO.File.AppendAllText(@".\vystup5.txt", signedVectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6], objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2]) + "\n");
            */
            joints[14] = signedVectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6], objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2]);

            i = 15;
            j = 16;
            /*System.IO.File.AppendAllText(@".\vystup5.txt",
            " | 1. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2]) * 180 / Math.PI) +
            " | 2. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 3. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 4. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 5. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 6. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) + "\n");

            System.IO.File.AppendAllText(@".\vystup5.txt", signedVectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10], objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6]) + "\n");
            */
            joints[15] = signedVectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10], objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6]);

            i = 0;
            j = 17;
            /*System.IO.File.AppendAllText(@".\vystup5.txt",
            " | 1. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2]) * 180 / Math.PI) +
            " | 2. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 3. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 4. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 5. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 6. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) + "\n");

            System.IO.File.AppendAllText(@".\vystup5.txt", - signedVectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6], objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10]) + "\n");
            */
            joints[16] = -signedVectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6], objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10]);

            i = 17;
            j = 18;
            /*System.IO.File.AppendAllText(@".\vystup5.txt",
            " | 1. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2]) * 180 / Math.PI) +
            " | 2. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 3. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 4. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 5. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 6. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) + "\n");

            System.IO.File.AppendAllText(@".\vystup5.txt", signedVectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2], objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6]) + "\n");
            */
            joints[17] = signedVectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2], objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6]);

            i = 18;
            j = 19;
            /*System.IO.File.AppendAllText(@".\vystup5.txt",
            " | 1. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2]) * 180 / Math.PI) +
            " | 2. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 3. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 4. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 5. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 6. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) + "\n");

            System.IO.File.AppendAllText(@".\vystup5.txt", signedVectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10], objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2]) + "\n");
            */
            joints[18] = signedVectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10], objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2]);

            i = 19;
            j = 20;
            /*System.IO.File.AppendAllText(@".\vystup5.txt",
            " | 1. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2]) * 180 / Math.PI) +
            " | 2. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 3. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 4. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 5. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 6. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) + "\n");

            System.IO.File.AppendAllText(@".\vystup5.txt", signedVectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6], objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2]) + "\n");
            */
            joints[19] = signedVectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6], objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2]);

            i = 20;
            j = 21;
            /*System.IO.File.AppendAllText(@".\vystup5.txt",
            " | 1. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2]) * 180 / Math.PI) +
            " | 2. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 3. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 4. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 5. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 6. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) + "\n");

            System.IO.File.AppendAllText(@".\vystup5.txt", signedVectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6], objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2]) + "\n");
            */
            joints[20] = signedVectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6], objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2]);

            i = 21;
            j = 22;
            /*System.IO.File.AppendAllText(@".\vystup5.txt",
            " | 1. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][0], objectPseudoMatrixes[j][1], objectPseudoMatrixes[j][2]) * 180 / Math.PI) +
            " | 2. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 3. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][0], objectPseudoMatrixes[i][1], objectPseudoMatrixes[i][2], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 4. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][4], objectPseudoMatrixes[j][5], objectPseudoMatrixes[j][6]) * 180 / Math.PI) +
            " | 5. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) +
            " | 6. " + Math.Round(vectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10]) * 180 / Math.PI) + "\n");

            System.IO.File.AppendAllText(@".\vystup5.txt", signedVectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10], objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6]) + "\n");
            */
            joints[21] = signedVectorAngle(objectPseudoMatrixes[i][8], objectPseudoMatrixes[i][9], objectPseudoMatrixes[i][10], objectPseudoMatrixes[j][8], objectPseudoMatrixes[j][9], objectPseudoMatrixes[j][10], objectPseudoMatrixes[i][4], objectPseudoMatrixes[i][5], objectPseudoMatrixes[i][6]);


            actiontime = time - timeBefore;

            if (actiontime == 0)
            {
                if (begin == 0)
                    actiontime = 0.2;
                else
                    actiontime = 0;
            }
            if (time < begin + adjust)
                actiontime = 0;
            endtime = starttime + actiontime;
            //toto musime prerobit:)
            if (time >= begin + adjust)
            {
                if (first)
                {
                    for (int k = 0; k <= 21; k++)
                    {
                        if (joints[k] != 0)
                        {
                            JointMotion jointMotion = new JointMotion();
                            jointMotion.StartTime = 0;
                            jointMotion.Duration = 400;
                            if (k == 0)
                                jointMotion.Joint = Joints.GetJointTypeById("HE1");
                            if (k == 1)
                                jointMotion.Joint = Joints.GetJointTypeById("HE2");
                            if (k == 2)
                                jointMotion.Joint = Joints.GetJointTypeById("RAE1");
                            if (k == 3)
                                jointMotion.Joint = Joints.GetJointTypeById("RAE2");
                            if (k == 4)
                                jointMotion.Joint = Joints.GetJointTypeById("RAE3");
                            if (k == 5)
                                jointMotion.Joint = Joints.GetJointTypeById("RAE4");
                            if (k == 6)
                                jointMotion.Joint = Joints.GetJointTypeById("LAE1");
                            if (k == 7)
                                jointMotion.Joint = Joints.GetJointTypeById("LAE2");
                            if (k == 8)
                                jointMotion.Joint = Joints.GetJointTypeById("LAE3");
                            if (k == 9)
                                jointMotion.Joint = Joints.GetJointTypeById("LAE4");
                            if (k == 10)
                                jointMotion.Joint = Joints.GetJointTypeById("RLE1");
                            if (k == 11)
                                jointMotion.Joint = Joints.GetJointTypeById("RLE2");
                            if (k == 12)
                                jointMotion.Joint = Joints.GetJointTypeById("RLE3");
                            if (k == 13)
                                jointMotion.Joint = Joints.GetJointTypeById("RLE4");
                            if (k == 14)
                                jointMotion.Joint = Joints.GetJointTypeById("RLE5");
                            if (k == 15)
                                jointMotion.Joint = Joints.GetJointTypeById("RLE6");
                            if (k == 16)
                                jointMotion.Joint = Joints.GetJointTypeById("LLE1");
                            if (k == 17)
                                jointMotion.Joint = Joints.GetJointTypeById("LLE2");
                            if (k == 18)
                                jointMotion.Joint = Joints.GetJointTypeById("LLE3");
                            if (k == 19)
                                jointMotion.Joint = Joints.GetJointTypeById("LLE4");
                            if (k == 20)
                                jointMotion.Joint = Joints.GetJointTypeById("LLE5");
                            if (k == 21)
                                jointMotion.Joint = Joints.GetJointTypeById("LLE6");
                            jointMotion.StartPosition = 0;
                            jointMotion.EndPosition = joints[k];
                            jointMotions.Add(jointMotion);
                        }
                    }
                    first = false;
                    starttime = starttime + 0.4;
                    endtime = endtime + 0.4;
                }
                for (int k = 0; k <= 21; k++)
                {
                    if (joints[k] != oldjoints[k])
                    {
                        JointMotion jointMotion = new JointMotion();
                        jointMotion.StartTime = (int)((starttime) * 1000);
                        jointMotion.Duration = (int)((endtime) * 1000) - (int)((starttime) * 1000);
                        if (k == 0)
                            jointMotion.Joint = Joints.GetJointTypeById("HE1");
                        if (k == 1)
                            jointMotion.Joint = Joints.GetJointTypeById("HE2");
                        if (k == 2)
                            jointMotion.Joint = Joints.GetJointTypeById("RAE1");
                        if (k == 3)
                            jointMotion.Joint = Joints.GetJointTypeById("RAE2");
                        if (k == 4)
                            jointMotion.Joint = Joints.GetJointTypeById("RAE3");
                        if (k == 5)
                            jointMotion.Joint = Joints.GetJointTypeById("RAE4");
                        if (k == 6)
                            jointMotion.Joint = Joints.GetJointTypeById("LAE1");
                        if (k == 7)
                            jointMotion.Joint = Joints.GetJointTypeById("LAE2");
                        if (k == 8)
                            jointMotion.Joint = Joints.GetJointTypeById("LAE3");
                        if (k == 9)
                            jointMotion.Joint = Joints.GetJointTypeById("LAE4");
                        if (k == 10)
                            jointMotion.Joint = Joints.GetJointTypeById("RLE1");
                        if (k == 11)
                            jointMotion.Joint = Joints.GetJointTypeById("RLE2");
                        if (k == 12)
                            jointMotion.Joint = Joints.GetJointTypeById("RLE3");
                        if (k == 13)
                            jointMotion.Joint = Joints.GetJointTypeById("RLE4");
                        if (k == 14)
                            jointMotion.Joint = Joints.GetJointTypeById("RLE5");
                        if (k == 15)
                            jointMotion.Joint = Joints.GetJointTypeById("RLE6");
                        if (k == 16)
                            jointMotion.Joint = Joints.GetJointTypeById("LLE1");
                        if (k == 17)
                            jointMotion.Joint = Joints.GetJointTypeById("LLE2");
                        if (k == 18)
                            jointMotion.Joint = Joints.GetJointTypeById("LLE3");
                        if (k == 19)
                            jointMotion.Joint = Joints.GetJointTypeById("LLE4");
                        if (k == 20)
                            jointMotion.Joint = Joints.GetJointTypeById("LLE5");
                        if (k == 21)
                            jointMotion.Joint = Joints.GetJointTypeById("LLE6");
                        jointMotion.StartPosition = oldjoints[k];
                        jointMotion.EndPosition = joints[k];
                        jointMotions.Add(jointMotion);
                    }
                }
                joints.CopyTo(oldjoints, 0);
            }
        }
    }
}