﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;

namespace RobotBehaviourEditor.Formats
{
    /**
     *  A class representation of a &lt;phase&gt; tag in Xml for Jim
     * */
    class PhaseNodeForJim
    {
        private List<EffectorNodeForJim> moves = new List<EffectorNodeForJim>();

        public string name { get; set; }

        public string nextName { get; set; }

        public bool isFinal { get; set; }

        public int speedConstant { get; set; }
        
        public PhaseNodeForJim()
        {
            this.isFinal = false;
        }
        
        internal void addMove(EffectorNodeForJim node)
        {
            moves.Add(node);
        }

        internal List<EffectorNodeForJim> getMoves()
        {
            return new List<EffectorNodeForJim>(moves);
        }

        internal static PhaseNodeForJim parse(XmlReader reader)
        {
            PhaseNodeForJim node = new PhaseNodeForJim();
            while (reader.MoveToNextAttribute())
            {
                if ("name".Equals(reader.Name))
                    node.name = reader.Value;
                if ("next".Equals(reader.Name))
                    node.nextName = reader.Value;
                if ("isFinal".Equals(reader.Name))
                    node.isFinal = "true".Equals(reader.Value);
            }
            return node;
        }

        bool equals(Object o)
        {
            if (o == null)
                return false;
            return ((PhaseNodeForJim)o).name.Equals(this.name);
        }

        string ToString()
        {
            return "PhaseNodeForJim:" +
               " name: " + name +
               " nextName: " + nextName +
               " isFinal: " + isFinal +
               " duration: " + speedConstant;
        }       
    }
}
