﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Media.Media3D;

namespace RobotBehaviourEditor.Model.Physics
{
    class FrontalBodyPart : BodyPart
    {
        public Point3D[] FrontalPoints { get; private set; }
        Point3D[] InitialFrontalPoints { get; set; }

        /// <param name="strongPoints">relativne pozicie opornych casti ak stred je v [0,0,0]</param>
        public FrontalBodyPart (JointTypes name, BodyPart parent, Vector3D translation, double mass, Vector3D jointAnchor, Vector3D jointAxis, Point3D[] frontalPoints)
            : base(name, parent, translation, mass, jointAnchor, jointAxis)
	    {
            InitialFrontalPoints = frontalPoints;
	    }

        public override void ComputeLocation(Gyroscope gyroscope)
        {
            base.ComputeLocation(gyroscope);

            if (Parent == null)
            {
                FrontalPoints = InitialFrontalPoints;
                return;
            }

            FrontalPoints = new Point3D[InitialFrontalPoints.Length];

            for (int i = 0; i < InitialFrontalPoints.Length; i++)
                FrontalPoints[i] = TransformAll(InitialFrontalPoints[i], gyroscope);
        }
    }
}
