﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Media.Media3D;
using RobotBehaviourEditor.MotionEditor.Visualisation;
using System.Windows;

namespace RobotBehaviourEditor.Model.Physics
{
    class PhysicalModel
    {
        public Point3D CenterOfMass { get; set; }
        public List<Point> StabilityHull { get; set; }
        public Point CenterOfStabilityHull { get; set; }

        public PhysicalModel(Robot3D robot, Gyroscope gyroscope)
        {
            Body body = new Body(robot, gyroscope);
            CenterOfMass = body.CenterOfMass;
            
            StabilityHull hull = new StabilityHull(body);
            StabilityHull = hull.Points;
            CenterOfStabilityHull = hull.Center;
        }
    }
}
