﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace RobotBehaviourEditor.MotionEditor
{
    public partial class AngleForm : Form
    {
        public AngleForm()
        {
            InitializeComponent();
        }

        public delegate void AngleSelectedHandler(object sender, AngleEventArgs e);
        public event AngleSelectedHandler AngleSelected;

        protected virtual void OnAngleSelected(AngleEventArgs e)
        {
            if (AngleSelected != null) AngleSelected(this, e);
        }

        
        private void okButton_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void anglePanel_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;

            int size;
            if (anglePanel.Width > anglePanel.Height) size = anglePanel.Height - 1;
            else size = anglePanel.Width - 1;

            Rectangle rect = new Rectangle((anglePanel.Width - size) / 2, (anglePanel.Height - size) / 2, size, size);            
            g.FillEllipse(Brushes.White, rect);
            g.DrawEllipse(Pens.Black, rect);

            Rectangle rect2 = new Rectangle((anglePanel.Width - 4) / 2, (anglePanel.Height - 4) / 2, 4, 4);
            g.DrawEllipse(Pens.Red, rect2);
        }

        private void AngleForm_Deactivate(object sender, EventArgs e)
        {
            this.Close();
        }

        private void anglePanel_Click(object sender, EventArgs e)
        {
            OnAngleSelected(new AngleEventArgs(0));
        }

        private void anglePanel_Resize(object sender, EventArgs e)
        {
            this.Invalidate();
        }
    }
}
