﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using RobotBehaviourEditor.Model;

namespace RobotBehaviourEditor.MotionEditor
{
    public partial class ConditionForm : Form
    {
        public ConditionForm()
        {
            InitializeComponent();            
        }

        private JointCondition result = null;
        public JointCondition Result
        {
            get { return result; }
            set { result = value; }
        }

        private void ConditionForm_Load(object sender, EventArgs e)
        {
            jointCombo.Items.AddRange(Joints.JointItems);
        }

        private void jointCombo_SelectedIndexChanged(object sender, EventArgs e)
        {
            positionFromUpDown.Minimum = ((JointItem)jointCombo.SelectedItem).MinValue;
            positionFromUpDown.Maximum = ((JointItem)jointCombo.SelectedItem).MaxValue;
            positionToUpDown.Minimum = ((JointItem)jointCombo.SelectedItem).MinValue;
            positionToUpDown.Maximum = ((JointItem)jointCombo.SelectedItem).MaxValue;
        }

        private void okButton_Click(object sender, EventArgs e)
        {
            if (positionToUpDown.Value < positionFromUpDown.Value)
            {
                MessageBox.Show("Začiatok rozsahu natočenia kĺbu musí byť menší ako koniec rozsahu.", this.Text, MessageBoxButtons.OK, MessageBoxIcon.Information);
                DialogResult = DialogResult.None;
            }
            else
            {
                JointItem item = ((JointItem)jointCombo.SelectedItem);

                result = new JointCondition(item.Type, (double)positionFromUpDown.Value, (double)positionToUpDown.Value);
                this.Close();
            }
        }

        private void cancelButton_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
