﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace RobotBehaviourEditor.MotionEditor
{
    public partial class RepetitionForm : Form
    {
        private int repetitionCount = 2;
        public int RepetitionCount
        {
            get { return repetitionCount; }
            private set { repetitionCount = value; }
        }

        private int delayAfterFirst = 0;
        public int DelayAfterFirst
        {
            get { return delayAfterFirst; }
            private set { delayAfterFirst = value; }
        }

        private int delayBetweenRepetitions = 0;
        public int DelayBetweenRepetitions
        {
            get { return delayBetweenRepetitions; }
            private set { delayBetweenRepetitions = value; }
        }

        private RepetitionType repetitionType = RepetitionType.RepeatAsGroup;
        public RepetitionType RepetitionType
        {
            get { return repetitionType; }
            private set { repetitionType = value; }
        }

        public RepetitionForm()
        {
            InitializeComponent();
        }

        private void RepetitionForm_Load(object sender, EventArgs e)
        {

        }

        private void okButton_Click(object sender, EventArgs e)
        {
            try
            {
                RepetitionCount = int.Parse(repetitionCountText.Text);
                DelayAfterFirst = int.Parse(delayAfterFirstText.Text);
                DelayBetweenRepetitions = int.Parse(delayBetweenRepetitionsText.Text);
                if (repeatAsGroupRadio.Checked)
                    RepetitionType = RepetitionType.RepeatAsGroup;
                if (repeatIndividuallyRadio.Checked)
                    RepetitionType = RepetitionType.RepeatIndividually;
            }
            catch
            {
                DialogResult = DialogResult.None;
                MessageBox.Show("Niektorá zo zadaných hodnôt je chybná.", "Chybná hodnota", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }
    }
}
