﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace RobotBehaviourEditor.MotionEditor
{
    public partial class RunSpeciallyForm : Form
    {
        private RunSettings settings;
        public RunSettings Settings
        {
            get { return settings; }
            set { settings = value; }
        }

        public RunSpeciallyForm()
            : this(new RunSettings())
        {
        }

        public RunSpeciallyForm(RunSettings settings)
        {
            InitializeComponent();

            this.settings = settings;
            InitializeSettings();            
        }        

        private void InitializeSettings()
        {
            if (this.settings.Speed > 1)
            {
                fasterRadio.Checked = true;
                fasterText.Text = settings.Speed.ToString();
            }
            else
            {
                slowerRadio.Checked = true;
                slowerText.Text = (1 / settings.Speed).ToString();
            }
            startDelayText.Text = settings.StartDelay.ToString();
            stateDelayText.Text = settings.StateDelay.ToString();
        }

        private void runButton_Click(object sender, EventArgs e)
        {
            try
            {
                settings = new RunSettings();

                if (slowerRadio.Checked)
                    settings.Speed = 1 / double.Parse(slowerText.Text);
                else
                    settings.Speed = double.Parse(fasterText.Text);

                settings.StateDelay = int.Parse(stateDelayText.Text);
                settings.StartDelay = int.Parse(startDelayText.Text);
            }
            catch
            {
                DialogResult = DialogResult.None;
                MessageBox.Show("Niektoré zadané hodnoty sú v nesprávnom formáte.", "Chybný formát", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }
    }
}
