﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Windows.Media.Imaging;
using System.Windows;

namespace RobotBehaviourEditor.MotionEditor.Visualisation
{
    public static class Images
    {
        public readonly static BitmapImage MetalTexture = new BitmapImage();
        public readonly static BitmapImage FaceTexture = new BitmapImage();
        public readonly static BitmapImage HoverTexture = new BitmapImage();
        public readonly static BitmapImage SelectedTexture = new BitmapImage();
        public readonly static BitmapImage ComTexture = new BitmapImage();

        static Images()
        {
            InitImage(MetalTexture, "/Graphics/Metal.png");
            InitImage(FaceTexture, "/Graphics/Face.png");
            InitImage(HoverTexture, "/Graphics/Hover.png");
            InitImage(SelectedTexture, "/Graphics/Selected.png");
            InitImage(ComTexture, "/Graphics/Com.png");
        }

        private static void InitImage(BitmapImage img, string path)
        {
            img.BeginInit();
            img.StreamSource = Application.GetResourceStream(new Uri(path, UriKind.Relative)).Stream;
            img.EndInit();
        }
        
    }
}
