﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;
using RobotBehaviourEditor.MotionEditor.Configuration;

namespace RobotBehaviourEditor
{
    static class Program
    {
        private static string configFileName;
        public static string ConfigFileName
        {
            get { return configFileName; }
            private set { configFileName = value; }
        }

        private static ProgramConfiguration config = new ProgramConfiguration();
        public static ProgramConfiguration Config
        {
            get { return config; }
            private set { config = value; }
        }


        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            ConfigFileName = Application.ExecutablePath.Substring(0, Application.ExecutablePath.LastIndexOf("\\") + 1) + "app.config";
            LoadConfiguration();

            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new BehaviourEditorForm());
        }

        public static void LoadConfiguration()
        {
            config = ProgramConfiguration.Load(configFileName);
            if (string.IsNullOrEmpty(config.TempFileName))
            {
                config.TempFileName = Application.ExecutablePath.Substring(0, Application.ExecutablePath.LastIndexOf("\\") + 1) + "Temp\\";
                if (!System.IO.Directory.Exists(config.TempFileName))
                {
                    System.IO.Directory.CreateDirectory(config.TempFileName);
                }
            }
        }
    }
}
