﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using RobotBehaviourEditor.MotionEditor.Visualisation;
using RobotBehaviourEditor.Model;
using RobotBehaviourEditor.ServerMessageParsing;

namespace RobotBehaviourEditor.ServerMessageAnalyzer
{
    public partial class VisualisationForm : Form
    {
        Robot3DControl robot3DControl;

        public VisualisationForm()
        {
            InitializeComponent();
        }

        private void VisualisationForm_Load(object sender, EventArgs e)
        {
            robot3DControl = new Robot3DControl();
            elementHost1.HostContainer.Children.Add(robot3DControl); 
        }

        internal static void OpenServerMessageFile(string fileName, Form mdiParent)
        {
            VisualisationForm frm = new VisualisationForm();
            frm.MdiParent = mdiParent;
            frm.Show();
            frm.OpenFile(fileName);
        }

        private void OpenFile(string fileName)
        {
            ServerMessageParser parser = new ServerMessageParser(fileName);
            List<JointMotion> motions = parser.ParseMotions();

            robot3DControl.JointMotions = motions;
        }
    }
}
