﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MathNet.Numerics.LinearAlgebra;


namespace RobotBehaviourEditor.Utils
{
    class Plain
    {
        public double a = 0;
        public double b = 0;
        public double c = 0;
        private double[][] matDataB = new double[3][];
        private double[][] matDataA = new double[3][];
        public double[][] abc = new double[3][];
        private Matrix matA;
        private Matrix matB;
        private Matrix matC;

        private void init()
        {
            for (int i = 0; i < 3; i++)
            {
                matDataB[i] = new double[1];
                abc[i] = new double[1];
            }
            for (int i = 0; i < 3; i++)
            {
                matDataA[i] = new double[3];
            }
        }

        public Plain()
        {
            init();
        }

        public Plain(double[] point1, double[] point2, double[] point3)
        {
            init();
            matDataB[0][0] = 1;
            matDataB[1][0] = 1;
            matDataB[2][0] = 1;
            for (int i = 0; i < 3; i++)
            {
                matDataA[0][i] = point1[i];
                matDataA[1][i] = point2[i];
                matDataA[2][i] = point3[i];
            }
            matA = new Matrix(matDataA);
            matB = new Matrix(matDataB);


            matC = matA.Solve(matB);
            this.abc = matC.GetArray();
            this.a = abc[0][0];
            this.b = abc[1][0];
            this.c = abc[2][0];
        }

        public Plain(Plain plain1, Plain plain2, double[] point)
        {
            init();
            matDataB[0][0] = 0;
            matDataB[1][0] = 0;
            matDataB[2][0] = 1;
            for (int i = 0; i < 3; i++)
            {
                matDataA[0][i] = plain1.abc[i][0];
                matDataA[1][i] = plain2.abc[i][0];
                matDataA[2][i] = point[i];
            }
            matA = new Matrix(matDataA);

            matB = new Matrix(matDataB);


            matC = matA.Solve(matB);
            this.abc = matC.GetArray();
            this.a = abc[0][0];
            this.b = abc[1][0];
            this.c = abc[2][0];
        }

        public Plain(Plain plain, double[] point1, double[] point2)
        {
            init();
            matDataB[0][0] = 0;
            matDataB[1][0] = 1;
            matDataB[2][0] = 1;
            for (int i = 0; i < 3; i++)
            {
                matDataA[0][i] = plain.abc[i][0];
                matDataA[1][i] = point1[i];
                matDataA[2][i] = point2[i];
            }
            matA = new Matrix(matDataA);
            matB = new Matrix(matDataB);

            matC = matA.Solve(matB);
            this.abc = matC.GetArray();
            this.a = abc[0][0];
            this.b = abc[1][0];
            this.c = abc[2][0];
        }

        public int getsign(Plain plain)
        {
            if (0 >= (this.a * plain.a + this.b * plain.b + this.c * plain.c))
                return -1;
            else
                return 1;
        }

        public double sinus(Plain plain)
        {
            return Math.Asin(((this.a * plain.a + this.b * plain.b + this.c * plain.c) / Math.Sqrt((this.a * this.a + this.b * this.b + this.c * this.c) * (plain.a * plain.a + plain.b * plain.b + plain.c * plain.c)))) * 180 / Math.PI;
        }

        public double cosinus(Plain plain)
        {
            return Math.Acos(((this.a * plain.a + this.b * plain.b + this.c * plain.c) / Math.Sqrt((this.a * this.a + this.b * this.b + this.c * this.c) * (plain.a * plain.a + plain.b * plain.b + plain.c * plain.c)))) * 180 / Math.PI;
        }

        public double angleOfPlains(Plain plain)
        {
            double fi;
            fi = Math.Acos(Math.Abs((this.a * plain.a + this.b * plain.b + this.c * plain.c) / Math.Sqrt((this.a * this.a + this.b * this.b + this.c * this.c) * (plain.a * plain.a + plain.b * plain.b + plain.c * plain.c)))) * 180 / Math.PI;
            return fi;
        }
    }
}

